
/* Daniel Karlsson, sep 2003		  */
/* Filename: misc.c                   */

// Check if all these includes are needed
#include <stdlib.h>
#include <stdio.h>   /* Standard input/output definitions */
#include <unistd.h>  /* UNIX standard function definitions */
#include <termios.h>

#include <time.h>    /* Is used for the delay loop */
#include "misc.h"

/* Delay function where t is sekonds  */
void delay(float seconds) {
   clock_t start_time;
   start_time = clock();
   while((clock() - start_time) < seconds * CLOCKS_PER_SEC) {
   }
}

/* Clear screen function */
void clrscr(void) {
   printf("\033[2J"); /* clear screen */
   printf("\033[0;0f"); /* move cursor to top left corner */
}

/***************************************************************/
/* Below is nessesary code for the "getkey()" function to work */
/***************************************************************/
static struct termios stored_settings; /* Used by the 'getKey' function process */

/* Makes reading without CR possible */
void set_keypress(void) {
   struct termios new_settings;
   tcgetattr(0,&stored_settings);
   new_settings = stored_settings;
   new_settings.c_lflag &= (~ICANON);
   new_settings.c_cc[VTIME] = 0;
   new_settings.c_cc[VMIN] = 1;
   tcsetattr(0,TCSANOW,&new_settings);
   return;
}

/* Resets to original values */
void reset_keypress(void) {
   tcsetattr(0,TCSANOW,&stored_settings);
   return;
}

/* Read keyboardinputs without CR */
char getKey(void) {
   char temp[2];
   set_keypress(); /* turn off CR request */
   fgets(temp,2,stdin);
   reset_keypress(); /* restore CR request */
   return temp[0];
}

